    //#new(backend):                                     //- [Y]  if new (backend) to add
    //#Event:                                            //- event to monitor in a loop
    //#Loop:                                             //- function to run at start of loop
    //#Stream:                                           //- [Y]  if Stream to manage
    //#
#pragma once
#include "B4RDefines.h"
#include "AXP192.h"

    //~Event: 
    //~Version: 1.0 
    //~Author - 
    //~Libray from Arduino

namespace B4R {
    //~shortname:AXP192 
    class B4RAXP192 
    {
        private:
            AXP192 axp192;
        public:
//?? {
//??     AXP192()
            void begin(bool disableLDO2, bool disableLDO3, bool disableRTC, bool disableDCDC1, bool disableDCDC3);
            void ScreenBreath(byte brightness);
            bool GetBatState();
            byte GetInputPowerStatus();
            byte GetBatteryChargingStatus();
            void EnableCoulombcounter();
            void DisableCoulombcounter();
            void StopCoulombcounter();
            void ClearCoulombcounter();
            ulong GetCoulombchargeData();
            ulong GetCoulombdischargeData();
            double GetCoulombData();
            uint GetVbatData() __attribute__((deprecated));
            uint GetIchargeData() __attribute__((deprecated));
            uint GetIdischargeData() __attribute__((deprecated));
            uint GetTempData() __attribute__((deprecated));
            ulong GetPowerbatData() __attribute__((deprecated));
            uint GetVinData() __attribute__((deprecated));
            uint GetIinData() __attribute__((deprecated));
            uint GetVusbinData() __attribute__((deprecated));
            uint GetIusbinData() __attribute__((deprecated));
            uint GetVapsData() __attribute__((deprecated));
            byte GetBtnPress();
            void SetSleep();
            void DeepSleep(uint64_t time_in_us);
            void LightSleep(uint64_t time_in_us);
            byte GetWarningLeve() __attribute__((deprecated));
            void SetChargeCurrent(byte);
            double GetBatVoltage();
            double GetBatCurrent();
            double GetVinVoltage();
            double GetVinCurrent();
            double GetVBusVoltage();
            double GetVBusCurrent();
            double GetTempInAXP192();
            double GetBatPower();
            double GetBatChargeCurrent();
            double GetAPSVoltage();
            double GetBatCoulombInput();
            double GetBatCoulombOut();
            byte GetWarningLevel();
            void SetCoulombClear(?? )  __attribute__((deprecated));
            void SetLDO2(bool State);
            void SetLDO3(bool State);
            void SetAdcState(bool State);
            void PowerOff();
            void Read6BytesStorage(ArrayByte* bufPtr);
            void Write6BytesStorage(ArrayByte* bufPtr);
    }
}
